Botan 1.10.17

Public Member Functions | Protected Member Functions | Private Member Functions | List of all members
Botan::ECB_Encryption Class Reference

`#include <ecb.h>`

Inheritance diagram for Botan::ECB_Encryption:

## Public Member Functions
virtual bool | attachable ()
| ECB_Encryption (BlockCipher *ciph, BlockCipherModePaddingMethod *pad)
| ECB_Encryption (BlockCipher *ciph, BlockCipherModePaddingMethod *pad, const SymmetricKey &key)
std::string | name () const
virtual void | set_iv (const InitializationVector &iv)
void | set_key (const SymmetricKey &key)
virtual void | start_msg ()
virtual bool | valid_iv_length (size_t length) const
bool | valid_keylength (size_t key_len) const
| ~ECB_Encryption ()

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Private Member Functions
void | buffer_reset ()
size_t | buffered_block_size () const
size_t | current_position () const

## Detailed Description

ECB Encryption

Definition at line 21 of file ecb.h.

## Constructor & Destructor Documentation

## ◆ ECB_Encryption() [1/2]

Botan::ECB_Encryption::ECB_Encryption | ( | BlockCipher * | ciph,
|  | BlockCipherModePaddingMethod * | pad
| ) |  |

Definition at line 15 of file ecb.cpp.

References Botan::Buffered_Filter::buffered_block_size(), and Botan::MemoryRegion< T >::resize().

16 :
17 Buffered_Filter(ciph->parallel_bytes(), 0)
18 {
19 cipher = ciph;
20 padder = pad;
21
22 temp.resize(buffered_block_size());
23 }
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:217
Botan::Buffered_Filter::buffered_block_size
size_t buffered_block_size() const
Definition: buf_filt.h:67
Botan::Buffered_Filter::Buffered_Filter
Buffered_Filter(size_t block_size, size_t final_minimum)
Definition: buf_filt.cpp:18

## ◆ ECB_Encryption() [2/2]

Botan::ECB_Encryption::ECB_Encryption | ( | BlockCipher * | ciph,
|  | BlockCipherModePaddingMethod * | pad,
|  | const SymmetricKey & | key
| ) |  |

Definition at line 28 of file ecb.cpp.

References Botan::Buffered_Filter::buffered_block_size(), Botan::MemoryRegion< T >::resize(), and Botan::SymmetricAlgorithm::set_key().

30 :
31 Buffered_Filter(ciph->parallel_bytes(), 0)
32 {
33 cipher = ciph;
34 padder = pad;
35
36 temp.resize(buffered_block_size());
37
38 cipher->set_key(key);
39 }
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:217
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60
Botan::Buffered_Filter::buffered_block_size
size_t buffered_block_size() const
Definition: buf_filt.h:67
Botan::Buffered_Filter::Buffered_Filter
Buffered_Filter(size_t block_size, size_t final_minimum)
Definition: buf_filt.cpp:18

## ◆ ~ECB_Encryption()

Botan::ECB_Encryption::~ECB_Encryption | ( |  | ) |

Definition at line 44 of file ecb.cpp.

45 {
46 delete cipher;
47 delete padder;
48 }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ name()

std::string Botan::ECB_Encryption::name | ( |  | ) | const
| virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 53 of file ecb.cpp.

References Botan::Algorithm::name(), and Botan::BlockCipherModePaddingMethod::name().

54 {
55 return (cipher->name() + "/ECB/" + padder->name());
56 }
Botan::Algorithm::name
virtual std::string name() const =0
Botan::BlockCipherModePaddingMethod::name
virtual std::string name() const =0

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protected inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::MemoryRegion< T >::size(), and Botan::Filter::write().

Referenced by Botan::PK_Encryptor_Filter::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), Botan::Zlib_Decompression::end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Zlib_Compression::write(), Botan::Bzip_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), Botan::Zlib_Decompression::write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:158
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ set_iv()

void Botan::Keyed_Filter::set_iv | ( | const InitializationVector & | iv | ) |
| virtual inherited

Set the initialization vector of this filter. Note: you should call set_iv() only after you have called set_key()

Parameters

  iv | the initialization vector to use

Reimplemented in Botan::CBC_Decryption, Botan::XTS_Decryption, Botan::CTS_Decryption, Botan::CFB_Decryption, Botan::StreamCipher_Filter, Botan::CBC_Encryption, Botan::EAX_Base, Botan::XTS_Encryption, Botan::CFB_Encryption, and Botan::CTS_Encryption.

Definition at line 13 of file basefilt.cpp.

References Botan::OctetString::length(), and Botan::Filter::name().

Referenced by Botan::get_cipher().

14 {
15 if(iv.length() != 0)
16 throw Invalid_IV_Length(name(), iv.length());
17 }
Botan::Filter::name
virtual std::string name() const =0

## ◆ set_key()

void Botan::ECB_Encryption::set_key | ( | const SymmetricKey & | key | ) |
| inline virtual

Set the key of this filter

Parameters

  key | the key to use

Implements Botan::Keyed_Filter.

Definition at line 27 of file ecb.h.

27 { cipher->set_key(key); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ start_msg()

virtual void Botan::Filter::start_msg | ( |  | ) |
| inline virtual inherited

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented in Botan::Zlib_Decompression, Botan::EAX_Base, Botan::Bzip_Decompression, Botan::PBE_PKCS5v20, Botan::PBE_PKCS5v15, Botan::Bzip_Compression, and Botan::Zlib_Compression.

Definition at line 38 of file filter.h.

38 {}

## ◆ valid_iv_length()

virtual bool Botan::Keyed_Filter::valid_iv_length | ( | size_t | length | ) | const
| inline virtual inherited

Check whether an IV length is valid for this filter

Parameters

  length | the IV length to be checked for validity

Returns
  true if the IV length is valid, false otherwise

Reimplemented in Botan::CBC_Decryption, Botan::XTS_Decryption, Botan::CTS_Decryption, Botan::CFB_Decryption, Botan::StreamCipher_Filter, Botan::EAX_Base, Botan::CBC_Encryption, Botan::CFB_Encryption, Botan::CTS_Encryption, and Botan::XTS_Encryption.

Definition at line 48 of file key_filt.h.

49 { return (length == 0); }

## ◆ valid_keylength()

bool Botan::ECB_Encryption::valid_keylength | ( | size_t | length | ) | const
| inline virtual

Check whether a key length is valid for this filter

Parameters

  length | the key length to be checked for validity

Returns
  true if the key length is valid, false otherwise

Implements Botan::Keyed_Filter.

Definition at line 29 of file ecb.h.

30 { return cipher->valid_keylength(key_len); }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51

The documentation for this class was generated from the following files:

- src/filters/modes/ecb/ecb.h
- src/filters/modes/ecb/ecb.cpp